int boxL = 400; //screen width and height
int iter = 10; //11 iterations..up to v^11 calculations done
ComplexNum v1,v2,v3,v4,v5,v6,v7,v8,v9,v10;
ComplexNum[] vArr = new ComplexNum[11];
ComplexNum initial = new ComplexNum(1,0);
ComplexNum zero = new ComplexNum(0,0);


void setup()
{
  size(boxL, boxL);  
}

void draw()
{
  background(0,0,0);
  noStroke();
  ellipse(200,200,2,2);//Center Circle
  
 
  ComplexNum V = TranslateMouseLoc(mouseX,mouseY);
  //println(V.a + " " + V.b);
  v1 = V;
  //V = new ComplexNum(.664,-.336);
  //v1 = V;
  v2 = Multiply(V,V);
  v3 = Multiply(V,v2);
  v4 = Multiply(V,v3);
  v5 = Multiply(V,v4);
  v6 = Multiply(V,v5);
  v7 = Multiply(V,v6);
  v8 = Multiply(V,v7);
  v9 = Multiply(V,v8);
  v10= Multiply(V,v9);
  
  vArr[0]= initial;
  vArr[1]= v1;
  vArr[2]= v2;
  vArr[3]= v3;
  vArr[4]= v4;
  vArr[5]= v5;
  vArr[6]= v6;
  vArr[7]= v7;
  vArr[8]= v8;
  vArr[9]= v9;
  vArr[10]=v10;
  
  computeV(zero,0);
}



public void computeV(ComplexNum A, int i)
{
  //recursiveberries
  if(i < 11)
  {
  computeV(Add(vArr[i],A), i+1);
  computeV(Subtract(A,vArr[i]), i+1);
  
  //Colorberries
  if(i%2 == 0)
  {
    //green
   fill(173,255,47);
  }
  else
  {
    //pink
    fill(199,21,133);
  }
  //circleberries
  ellipse(TranslateXloc(Add(vArr[i],A)), TranslateYloc(Add(vArr[i],A)), 2, 2);
  ellipse(TranslateXloc(Subtract(A, vArr[i])), TranslateYloc(Subtract(A,vArr[i])), 2, 2);
  }

 
}

//new class for complex number and the data it holds
class ComplexNum
{
  float a, b;
  
    //construct new complex number
    ComplexNum(float aVal, float bVal)
    {
      a = aVal;
      b = bVal;
    }
    
}
    //(a + bi) + (c + di): = (a + c) + (b + d)i
    public ComplexNum Add(ComplexNum a, ComplexNum b)
    {
      float newA, newB;
      
      newA = a.a + b.a;
      newB = a.b + b.b;
      
      ComplexNum multiCN = new ComplexNum(newA, newB);
      return multiCN;
    }
    
    
    //(a + bi)(c + di) = (ac − bd) + (bc + ad)i.
    public ComplexNum Multiply(ComplexNum a, ComplexNum b)
    {
      float newA, newB;
      
      newA = a.a*b.a - a.b*b.b;
      newB = a.b*b.a + a.a*b.b;
      
      ComplexNum multiCN = new ComplexNum(newA, newB);
      return multiCN;
    }
    
    //(a + bi) − (c + di) = (a − c) + (b − d)i.
    public ComplexNum Subtract(ComplexNum a, ComplexNum b)
    {
      float newA, newB;
      
      newA = a.a - b.a;
      newB = a.b - b.b;
      
      ComplexNum multiCN = new ComplexNum(newA, newB);
      return multiCN;
    }


//Changes the x,y coordinate got by mouseX and mouseY to x,y vals between [-2,2]
public ComplexNum TranslateMouseLoc(float mouseLocX, float mouseLocY)
{
   float aNew, bNew;
   aNew = (mouseLocX*.01)-2;
   bNew = -((mouseLocY*.01)-2);
  
  ComplexNum cn = new ComplexNum(aNew, bNew);
  
  return cn;
}

public float TranslateXloc(ComplexNum a)
{
  float A = a.a;
  return 100*(A+2); 
}

public float TranslateYloc(ComplexNum a)
{
  float B = a.b;
  return 100*(-B+2);
}
